## libgdchart-gd2 0.11.5

=== Makefile ===
CC=gcc
# gcc 2.7.1 or better is required
# CFLAGS=
# CFLAGS=-g -ansi -pedantic

# ----- build path -----
GDC_INCL=./
GDC_LD=./
GDC_LIB=libgdc.a

# ----- install locations -----
PREFIX_INC = /usr/local/include
PREFIX_LIB = /usr/local/lib

# INCLUDEDIRS=-I. -I/usr/include/freetype2 -I/usr/include/X11 -I/usr/X11R6/include/X11 -I/usr/local/include 

# ----- lib gd -----
# GDChart requires the gd library - www.boutell.com/gd/
# gd 2.0.28 or better is required (GIF support has returned to libgd)
# if it's not installed in a standard location edit these lines for your installation
GD_INCL=/usr/local/include/
GD_LD=/usr/local/lib/
GD_LIB=libgd.so
# a static libgd is also available
# GD_LIB=libgd.a

# ----- lib png -----
# libgd requires libpng
# if it's not installed in a standard location edit these lines for your installation
# PNG_INCL = ../libpng-1.0.8
# PNG_LD   = ../libpng-1.0.8

# ----- lib z -----
# libgd requires zlib
# if it's not installed in a standard location edit these lines for your installation
# ZLIB_INCL = ../zlib-1.1.3
# ZLIB_LD   = ../zlib-1.1.3

# ----- lib jpeg -----
# libgd optionally uses libjpeg to produce JPEG images
# JPEG_INCL = ../libjpeg
# JPEG_LD   = ../libjpeg
JPEG_DEF  = -DHAVE_JPEG
JPEG_LK   = -ljpeg

# libgd optionally uses libfreetype to use TTFs
# FT_LD  = /usr/local/lib
FT_DEF    = -DHAVE_LIBFREETYPE
FT_LK     = -lfreetype

DEFS = $(FT_DEF) $(JPEG_DEF)
LIBS = $(FT_LK) $(JPEG_LK)

LIB_PATHS   = -L$(GD_LD) -L$(GDC_LD)
# if not installed in standard paths (/lib, /usr/lib), or LD_LIBRARY_PATH
# LIB_PATHS   = -L$(GD_LD) -L$(PNG_LD) -L$(ZLIB_LD) -L$(JPEG_LD)

# NOTE:
# libpng, libz, etc. are usually linked in as dynamic libs
# either use a link line similar to one of these, or set environment LD_LIBRARY_PATH
# these should likely be absolute paths, as resolved at runtime
# LIB_PATHS = $(LIB_PATHS) -R$(PNG_LD) -R$(ZLIB_LD)
# LIB_PATHS = $(LIB_PATHS) -Xlinker -rpath -Xlinker $(PNG_LD) -Xlinker -rpath -Xlinker $(ZLIB_LD)


all: libgdc.a gdc_samp1 gdc_samp2 gdc_pie_samp ft_samp

# --- compile the samples ---
gdc_pie_samp.o: $(GDC_INCL)gdc.h $(GDC_INCL)gdcpie.h gdc_pie_samp.c
	$(CC) $(CFLAGS) -I$(GDC_INCL) $(DEFS) -c gdc_pie_samp.c

gdc_samp1.o: $(GDC_INCL)gdc.h $(GDC_INCL)gdchart.h gdc_samp1.c
	$(CC) $(CFLAGS) -I$(GDC_INCL) $(DEFS) -c gdc_samp1.c

gdc_samp2.o: $(GDC_INCL)gdc.h $(GDC_INCL)gdchart.h gdc_samp2.c
	$(CC) $(CFLAGS) -I$(GDC_INCL) $(DEFS) -c gdc_samp2.c

ft_samp.o: $(GDC_INCL)gdc.h $(GDC_INCL)gdchart.h ft_samp.c
	$(CC) $(CFLAGS) -I$(GDC_INCL) $(DEFS) -c ft_samp.c

# --- link the samples ---
gdc_samp1: $(GDC_LD)libgdc.a gdc_samp1.o $(GD_LD)/$(GD_LIB) $(GDC_LD)/$(GDC_LIB)
	$(CC) -o gdc_samp1 \
			 gdc_samp1.o \
			 $(LIB_PATHS) \
			 -lgdc -lgd -lz -lpng $(LIBS) -lm

gdc_samp2: $(GDC_LD)libgdc.a gdc_samp2.o $(GD_LD)/$(GD_LIB) $(GDC_LD)/$(GDC_LIB)
	$(CC) -o gdc_samp2 \
			 gdc.o gdchart.o price_conv.o \
			 gdc_samp2.o \
			 $(LIB_PATHS) \
			 -lgdc -lgd -lz -lpng $(LIBS) -lm

gdc_pie_samp: $(GDC_LD)libgdc.a gdc_pie_samp.o $(GD_LD)/$(GD_LIB) $(GDC_LD)/$(GDC_LIB)
	$(CC) -o gdc_pie_samp \
			 gdc.o gdc_pie.o price_conv.o \
			 gdc_pie_samp.o \
			 $(LIB_PATHS) \
			 -lgdc -lgd -lz -lpng $(LIBS) -lm

ft_samp: $(GDC_LD)libgdc.a ft_samp.o $(GD_LD)/$(GD_LIB) $(GDC_LD)/$(GDC_LIB)
	$(CC) -o ft_samp \
			 gdc.o gdchart.o price_conv.o \
			 ft_samp.o \
			 $(LIB_PATHS) \
			 -lgdc -lgd -lz -lpng $(LIBS) -lm

# --- compile the lib ---
gdc.h: $(GD_INCL)gd.h $(GD_INCL)gdfonts.h $(GD_INCL)gdfontt.h $(GD_INCL)gdfontmb.h $(GD_INCL)gdfontg.h $(GD_INCL)gdfontl.h $(GDC_INCL)array_alloc.h

price_conv.o: price_conv.c
	$(CC) $(CFLAGS) -c price_conv.c

gdc.o: gdc.c $(GDC_INCL)gdc.h
	$(CC) $(CFLAGS) -I$(GD_INCL) -I$(GDC_INCL) $(DEFS) -c gdc.c

gdc_pie.o: $(GDC_INCL)gdc.h $(GDC_INCL)gdcpie.h gdc_pie.c
	$(CC) $(CFLAGS) -I$(GD_INCL) -I$(GDC_INCL) $(DEFS) -c gdc_pie.c

gdchart.o: $(GDC_INCL)gdc.h $(GDC_INCL)gdchart.h gdchart.c
	$(CC) $(CFLAGS) -I$(GD_INCL) -I$(GDC_INCL) $(DEFS) -c gdchart.c

array_alloc.o: array_alloc.c array_alloc.h
	$(CC) $(CFLAGS) -c array_alloc.c

libgdc.a: price_conv.o gdc.o gdc_pie.o gdchart.o array_alloc.o
	ar cr libgdc.a gdc.o gdchart.o gdc_pie.o price_conv.o array_alloc.o
	ranlib libgdc.a

# --- supporting libraries ---
# should be compile & installed separately
# $(GD_LD)/$(GD_LIB):
# 	cd $(GD_LD) ; make -f Makefile $(GD_LIB)

# ----- install -----
install: gdc.h gdchart.h gdcpie.h libgdc.a
	cp gdc.h  gdchart.h  gdcpie.h $(PREFIX_INC)/
	cp libgdc.a $(PREFIX_LIB)/

# --- clean ---
clean:
	rm -f *.o *.a gdc_samp1 gdc_samp2 gdc_pie_samp ft_samp

=== debian/changelog ===
libgdchart-gd2 (0.11.5-12.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Do not Depends on dummy dh-buildinfo
  * Drop debian/control.in
  * Remove code related to new upstream release that will never happen
    & upstream-tarball.mk logic removed from CDBS in favor of uscan

 -- Alexandre Detiste <tchet@debian.org>  Sun, 05 Oct 2025 14:19:22 +0200

libgdchart-gd2 (0.11.5-12.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Stop including /usr/share/cdbs/1/rules/upstream-tarball.mk
  * Switch debian/watch to v4

 -- Alexandre Detiste <tchet@debian.org>  Fri, 01 Aug 2025 16:05:05 +0200

libgdchart-gd2 (0.11.5-12.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fixing build with GCC-14 (Closes: #1075170)

 -- Pierre Gruet <pgt@debian.org>  Sat, 27 Jul 2024 14:30:47 +0200

libgdchart-gd2 (0.11.5-12) unstable; urgency=medium

  * Team upload.
  * d/control: Mark the -{non,}xpm packages as conflicting with their
    counterparts. Closes: #1067215

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 21 Mar 2024 13:02:15 +0100

libgdchart-gd2 (0.11.5-11) unstable; urgency=medium

  * Team upload

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces

  [ Michael R. Crusoe ]
  * d/patches/1003_string_include.patch: add missing include. Closes:
    #1066345, #1065971
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Trim trailing whitespace.
  * d/control: remove obsolete references to the binary packages
    libgdchart & libgdchart-gd2-dev.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 19 Mar 2024 17:31:08 +0100

libgdchart-gd2 (0.11.5-10) unstable; urgency=medium

  * Team upload

  [ Andreas Tille ]
  * Move to salsa.d.o
  * Standards-Version: 4.1.3

  [ Matthias Klose ]
  * gdc.h: Remove make dependencies on system headers
    Closes:  #641692 (LP: #831241)

  [ Antonios Christofides ]
  * Add debian/README.Debian to save users trouble to find out usage
    Closes: #242936

  [ Helmut Grohne ]
  * Fix FTCBFS: Use a triplet-prefixed CC
    Closes: #880360

 -- Andreas Tille <tille@debian.org>  Wed, 28 Feb 2018 17:33:10 +0100

libgdchart-gd2 (0.11.5-9) unstable; urgency=medium

  * Team upload
  * Drop libgd2-noxpm-dev substitution
    Closes: #880872
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Mon, 13 Nov 2017 08:07:54 +0100

libgdchart-gd2 (0.11.5-8) unstable; urgency=medium

  * Team upload
  * Standards-Version: 3.9.6
  * debhelper 9
  * Build-Depends: libgd-dev instead of libgd2-noxpm-dev (>> 2.0.28)
    Closes: #791842

 -- Andreas Tille <tille@debian.org>  Thu, 16 Jul 2015 12:02:51 +0200

libgdchart-gd2 (0.11.5-7) unstable; urgency=low

  * Drop local CDBS snippets: All included in main cdbs package now.
    Local snippets might have been incompatible with recent releases of
    cdbs and contribute to a FTBFS.
    Closes: bug#564374. Thanks to Lucas Nussbaum and Philipp Kern.
  * Tighten build-dependency on cdbs and debhelper.
  * Switch to source format 3.0 (quilt).
  * Bump standards-version to 3.9.1.
  * Build-depend on dh-buildinfo.
  * Fix depend on ${misc:Depends}, thanks to lintian.
  * Development moved to Git:
    + Update Vcs-* stanzas.
    + Add git-buildpackage config, enabling sign-tags and pristine-tar.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 17 Sep 2010 05:42:23 +0200

libgdchart-gd2 (0.11.5-6) unstable; urgency=medium

  * Set urgency=medium as last packaging included a FTBFS bugfix
    (similar to bug#487066).

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 28 Jun 2008 20:50:23 +0200

libgdchart-gd2 (0.11.5-5) unstable; urgency=low

  * Invoke svn-upgrade (not uupdate) in debian/watch.
  * Move Vcs-* and Homepage to own fields in debian/control.
  * Update local cdbs tweaks:
    + Major updates to copyright-check.mk, most importantly relax to
      only warn by default.
    + Drop buildcore.mk (set hints manually instead as needed).
    + Various updates to update-tarball.mk, including changed wget
      options to work with recent versions of wget.
    + Cosmetic updates to README.cdbs-tweaks.
    + Update dependency cleanup to strip cdbs 0.4.27 (not 0.4.27-1).
  * Update debian/copyright-hints.
  * Bump debhelper compatibility level to 6.
  * Semi-auto-update debian/control to update build-dependencies:
      DEB_AUTO_UPDATE_DEBIAN_CONTROL=yes fakeroot debian/rules clean

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 28 Jun 2008 17:37:51 +0200

libgdchart-gd2 (0.11.5-4) unstable; urgency=low

  * Add XS-Vcs-Svn and XS-Vcs-Browser fields to debian/control.
  * Bump standards-version to 3.7.2 (no changes needed).
  * Tighten d-shlibs build-dependency and adjust -noxpm override, to fix
    resolving -dev dependencies with recent libgd2 releases. Closes:
    bug#427326, thanks to Lucas Nussbaum and Luis Rodrigo Gallardo Cruz.
  * Drop deprecated fallback build-dependencies on xfree86 packages, and
    override similar dependencies resolved by d-shlibs.
  * Update CDBS tweaks:
    + Add new upstream-tarball.mk: Add get-orig-source target and more.
    + Add new copyright-check.mk: Fail building if source contains new
      or changed copyrights.
    + Update buildinfo.mk: Fix touchfile to run only once.
    + Add new buildcore.mk: Enable auto-updating build-dependencies in
      debian/control when DEB_BUILD_OPTIONS contains cdbs-autoupdate
      (replacing similar custom tweak in debian/rules).
    + Add README.cdbs-tweaks documenting the added tweaks.
    + Advertise README.cdbs-tweaks in debian/rules.
    + Use patchsys-quilt (instead of simple-patchsys).
    + Declare (and strip duplicate) build-dependencies in debian/rules.
  * Use binNMU-safe ${binary:Version} (not ${Source-Version}) in
    debian/control.
  * Semi-auto-update debian/control:
      DEB_BUILD_OPTIONS=cdbs-autoupdate fakeroot debian/rules pre-build

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 05 Sep 2007 13:09:48 +0200



=== debian/control ===
Source: libgdchart-gd2
Maintainer: Jonas Smedegaard <dr@jones.dk>
Uploaders: Vasudev Kamath <kamathvasudev@gmail.com>
Section: libs
Priority: optional
Build-Depends: cdbs,
               debhelper (>= 9),
               libgd-dev,
               libxpm-dev,
               libxt-dev,
               d-shlibs
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/debian/libgdchart-gd2
Vcs-Git: https://salsa.debian.org/debian/libgdchart-gd2.git
Homepage: http://www.fred.net/brv/chart/
Rules-Requires-Root: no

Package: libgdchart-gd2-noxpm-dev
Architecture: any
Section: libdevel
Depends: ${devlibs:Depends},
         libgdchart-gd2-noxpm (= ${binary:Version}),
         ${misc:Depends}
Conflicts: libgdchart-gd2-xpm-dev
Description: Generate graphs using the GD library (development version)
 A library for generating nice 2d and 3d graphs with the use of GD.
 .
 This is the full development version of the library, built against GD 2.x
 library and without XPM (X pixmap) support.

Package: libgdchart-gd2-xpm-dev
Architecture: any
Section: libdevel
Depends: ${devlibs:Depends},
         libgdchart-gd2-xpm (= ${binary:Version}),
         ${misc:Depends}
Conflicts: libgdchart-gd2-noxpm-dev
Description: Generate graphs using the GD library (development version)
 A library for generating nice 2d and 3d graphs with the use of GD.
 .
 This is the full development version of the library, built against GD 2.x
 library and with XPM (X pixmap) support.

Package: libgdchart-gd2-noxpm
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: libgdchart-gd2-xpm
Description: Generate graphs using the GD library
 A library for generating nice 2d and 3d graphs with the use of GD.
 .
 This is the runtime package of the library, built against GD 2.x
 library and without XPM (X pixmap) support.

Package: libgdchart-gd2-xpm
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: libgdchart-gd2-noxpm
Description: Generate graphs using the GD library
 A library for generating nice 2d and 3d graphs with the use of GD.
 .
 This is the runtime package of the library, built against GD 2.x
 library and with XPM (X pixmap) support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2004-2007 Jonas Smedegaard <dr@jones.dk>

include /usr/share/dpkg/architecture.mk
include /usr/share/cdbs/1/class/makefile-vars.mk
include /usr/share/cdbs/1/rules/debhelper.mk

package=libgdchart-gd2
library=libgdc

DEB_DH_MAKESHLIBS_ARGS_$(package)-xpm = -V'$(package)-xpm'
DEB_DH_MAKESHLIBS_ARGS_$(package)-noxpm = -V'$(package)-noxpm | $(package)-xpm'

DEB_INSTALL_DIRS_ALL = usr/lib
DEB_INSTALL_DIRS_$(package)-xpm-dev = usr/include
DEB_INSTALL_DIRS_$(package)-noxpm-dev = usr/include

DEB_INSTALL_EXAMPLES_$(package)-xpm-dev = gdc_samp1.c gdc_samp2.c gdc_pie_samp.c ft_samp.c
DEB_INSTALL_EXAMPLES_$(package)-noxpm-dev = gdc_samp1.c gdc_samp2.c gdc_pie_samp.c ft_samp.c

# Dummy main build target (we build multiple targets)
DEB_BUILD_MAKE_TARGET = clean

version := $(shell expr `pwd` : '.*-\([0-9.]*\)')
version_major := $(shell expr `pwd` : '.*-\([0-9]*\).[0-9.]*')

ifeq ($(origin CC),default)
CC = $(DEB_HOST_GNU_TYPE)-gcc
endif

INCLUDEDIRS = -I. -I.. -I/usr/include/freetype2 -I/usr/include/freetype2/freetype
LIBS = -lc -lm -L/usr/lib -lpng -lz -ljpeg -lfreetype -lgd

CFLAGS += -D_REENTRANT -pipe -DHAVE_LIBPNG -DHAVE_LIBFREETYPE -DHAVE_LIBJPEG -fsigned-char
CFLAGS_$(package)-xpm = $(CFLAGS) -fPIC -DHAVE_XPM
CFLAGS_$(package)-noxpm = $(CFLAGS) -fPIC
CFLAGS_$(package)-xpm-dev = $(CFLAGS) -DHAVE_XPM
CFLAGS_$(package)-noxpm-dev = $(CFLAGS)

# Build shared libc6 library.
build/$(package)-xpm::
	make clean
	dh_testdir
	-mkdir $(package)-xpm
	cd $(package)-xpm && \
		$(DEB_MAKE_INVOKE) -f ../Makefile VPATH=".." srcdir=".." \
		INCLUDEDIRS="$(INCLUDEDIRS) -I/usr/include/X11" \
		CC='$(CC) $$(INCLUDEDIRS)' $(library).a
	cd $(package)-xpm && \
		$(CC) -shared -D_REENTRANT \
		-Wl,-soname,$(library).so.$(version_major) \
		-o $(library).so.$(version) \
		`echo *.o` \
		$(LIBS) -L/usr/X11R6/lib -lXpm -lX11

# Build shared libc6 library without XPM support.
build/$(package)-noxpm::
	make clean
	dh_testdir
	-mkdir $(package)-noxpm
	cd $(package)-noxpm && \
		$(DEB_MAKE_INVOKE) -f ../Makefile VPATH=".." srcdir=".." \
		INCLUDEDIRS="$(INCLUDEDIRS)" \
		CC='$(CC) $$(INCLUDEDIRS)' $(library).a
	cd $(package)-noxpm && \
		$(CC) -shared -D_REENTRANT \
		-Wl,-soname,$(library).so.$(version_major) \
		-o $(library).so.$(version) \
		`echo *.o` \
		$(LIBS)

# Build static libc6 library.
build/$(package)-xpm-dev::
	make clean
	dh_testdir
	-mkdir $(package)-xpm-dev
	cd $(package)-xpm-dev && \
		$(DEB_MAKE_INVOKE) -f ../Makefile VPATH=".." srcdir=".." \
		INCLUDEDIRS="$(INCLUDEDIRS) -I/usr/include/X11" \
		CC='$(CC) $$(INCLUDEDIRS)' $(library).a

# Build static libc6 library without XPM support.
build/$(package)-noxpm-dev::
	make clean
	dh_testdir
	-mkdir $(package)-noxpm-dev
	cd $(package)-noxpm-dev && \
		$(DEB_MAKE_INVOKE) -f ../Makefile VPATH=".." srcdir=".." \
		INCLUDEDIRS="$(INCLUDEDIRS)" \
		CC='$(CC) $$(INCLUDEDIRS)' $(library).a

clean::
	rm -rf $(package)-xpm $(package)-noxpm $(package)-xpm-dev $(package)-noxpm-dev

binary-install/$(package)-xpm::
	install -m644 $(package)-xpm/$(library).so.$(version) debian/$(package)-xpm/usr/lib/
	ln -sf $(library).so.$(version) debian/$(package)-xpm/usr/lib/$(library).so.$(version_major)

binary-install/$(package)-noxpm::
	install -m644 $(package)-noxpm/$(library).so.$(version) debian/$(package)-noxpm/usr/lib/
	ln -sf $(library).so.$(version) debian/$(package)-noxpm/usr/lib/$(library).so.$(version_major)

binary-install/$(package)-xpm-dev::
	install -m644 $(package)-xpm-dev/$(library).a debian/$(package)-xpm-dev/usr/lib
	install -m644 *.h debian/$(package)-xpm-dev/usr/include
	ln -sf $(library).so.$(version) debian/$(package)-xpm-dev/usr/lib/$(library).so

binary-install/$(package)-noxpm-dev::
	install -m644 $(package)-noxpm-dev/$(library).a debian/$(package)-noxpm-dev/usr/lib
	install -m644 *.h debian/$(package)-noxpm-dev/usr/include
	ln -sf $(library).so.$(version) debian/$(package)-noxpm-dev/usr/lib/$(library).so

# Let d-shlibs calculate development package dependencies
#  Suppress pre-sarge X11 fallback dependencies (bugreport not yet filed)
#  Favor -noxpm flavor of libgd, as we don't actually use the XPM calls
### TODO: Let d-shlibs intelligently handle shared library install
##common-binary-post-install-arch::
##	d-shlibmove --commit --movedev "*.h" usr/include/ $(package)-xpm/$(library).so
binary-fixup/$(package)-xpm-dev::
	d-devlibdeps \
		--override 's/ | xlibs-dev (<< 4.3.0)//' \
		--override 's/libgd3-dev/libgd-dev/' \
		debian/$(package)-xpm-dev.substvars $(package)-xpm/$(library).so.$(version)

binary-fixup/$(package)-noxpm-dev::
	d-devlibdeps \
		--override 's/ | xlibs-dev (<< 4.3.0)//' \
		--override 's/libgd3-dev/libgd-dev/' \
		debian/$(package)-noxpm-dev.substvars $(package)-noxpm/$(library).so.$(version)

# Little hack to have CDBS recognize readme.txt as main README file.
common-install-arch common-install-indep::
	cp -fp README.txt README

clean::
	rm -f README

=== debian/watch ===
# Run the "uscan" command to check for upstream updates and more.
version=4
http://www.fred.net/brv/chart/download.htm .*gdchart([\.0-9]+)dev.tar.gz debian svn-upgrade
